AbstractDynamicMethodsInterceptor (Grails 2.4.4)
Date: 2014-10-28

Package: org.codehaus.groovy.grails.commons.metaclass

## [Java] Class AbstractDynamicMethodsInterceptor

- org.codehaus.groovy.grails.commons.metaclass.AbstractDynamicMethodsInterceptor

- All Implemented Interfaces and Traits:
    ConstructorInterceptor, PropertyAccessInterceptor

      public abstract class AbstractDynamicMethodsInterceptor
      extends AbstractDynamicMethods

  Implements an the Interceptor interface to add support for using ProxyMetaClass to define dynamic methods.

  Authors:
    Graeme Rocher

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class AbstractDynamicMethods` | `clazz, dynamicConstructors, dynamicMethodInvocations, dynamicProperties, staticMethodInvocations`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `AbstractDynamicMethodsInterceptor ()`
    `AbstractDynamicMethodsInterceptor (java.lang.Class<?> theClass, boolean inRegistry)`
    `AbstractDynamicMethodsInterceptor (java.lang.Class<?> theClass)`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `java.lang.Object` | `afterConstructor(java.lang.Object[] args, java.lang.Object instantiatedInstance)`
    `java.lang.Object` | `afterInvoke(java.lang.Object object, java.lang.String methodName, java.lang.Object[] arguments, java.lang.Object result)`
    `java.lang.Object` | `beforeConstructor(java.lang.Object[] args, InvocationCallback callback)`
    `java.lang.Object` | `beforeGet(java.lang.Object object, java.lang.String property, InvocationCallback callback)`
    `java.lang.Object` | `beforeInvoke(java.lang.Object target, java.lang.String methodName, java.lang.Object[] arguments, InvocationCallback callback)`
    `void` | `beforeSet(java.lang.Object object, java.lang.String property, java.lang.Object newValue, InvocationCallback callback)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class AbstractDynamicMethods` | `addDynamicConstructor, addDynamicMethodInvocation, addDynamicProperty, addStaticMethodInvocation, getDynamicMethod, getDynamicProperty, getProperty, invokeConstructor, invokeMethod, invokeStaticMethod, setProperty`
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Constructor Detail

    - #### public AbstractDynamicMethodsInterceptor()

    - #### public AbstractDynamicMethodsInterceptor(java.lang.Class<?> theClass, boolean inRegistry)

    - #### public AbstractDynamicMethodsInterceptor(java.lang.Class<?> theClass)

  - ### Method Detail

    - #### public java.lang.Object afterConstructor(java.lang.Object[] args, java.lang.Object instantiatedInstance)

    - #### public java.lang.Object afterInvoke(java.lang.Object object, java.lang.String methodName, java.lang.Object[] arguments, java.lang.Object result)

    - #### public java.lang.Object beforeConstructor(java.lang.Object[] args, InvocationCallback callback)

    - #### public java.lang.Object beforeGet(java.lang.Object object, java.lang.String property, InvocationCallback callback)

    - #### public java.lang.Object beforeInvoke(java.lang.Object target, java.lang.String methodName, java.lang.Object[] arguments, InvocationCallback callback)

    - #### public void beforeSet(java.lang.Object object, java.lang.String property, java.lang.Object newValue, InvocationCallback callback)